<?php
$settings_page = 'belingo_geo_settings.php';

add_action('admin_menu', 'rewrite_rules_settings');
function rewrite_rules_settings() {
	add_options_page( 'Настройки плагина BelingoGeo', 'BelingoGeo', 'manage_options', 'belingo_geo_settings.php', 'belingo_geo_function' );
}

function belingo_geo_function($arr) {
	global $settings_page;

	if(isset($_POST)) {
		rewrite_rules_func();
	}

	echo '<div class="wrap">';
	echo '<h1>Настройки BelingoGeo <sup style="color:green;">v'.BELINGO_GEO_VERSION.'</sup></h1>';
	screen_icon();
	echo '<form method="post" action="options.php" enctype="multipart/form-data">';
	settings_fields('belingo_geo_excludes');
	do_settings_sections($settings_page);
	submit_button();
	echo '</form>';

	echo '</div>';
}

function belingo_geo_settings() {
	global $settings_page;
	register_setting( 'belingo_geo_excludes', 'belingo_geo_exclude_posts' );
	register_setting( 'belingo_geo_excludes', 'belingo_geo_exclude_pages' );
	register_setting( 'belingo_geo_excludes', 'belingo_geo_exclude_terms' );
	register_setting( 'belingo_geo_excludes', 'belingo_geo_basic_default_phone' );
	register_setting( 'belingo_geo_excludes', 'belingo_geo_basic_default_address' );
	register_setting( 'belingo_geo_excludes', 'belingo_geo_basic_brand_base' );
	register_setting( 'belingo_geo_excludes', 'belingo_geo_basic_brand_term' );
	add_settings_section( 'belingo_geo_basic', 'Общие', '', $settings_page );
	add_settings_section( 'belingo_geo_excludes', 'Исключения', '', $settings_page );

	add_settings_field( 
		'belingo_geo_basic_default_phone', 
		'Телефон по умолчанию', 
		'belingo_geo_display_settings', 
		$settings_page, 
		'belingo_geo_basic', 
		array( 
			'type'      => 'text',
			'option_name' => 'belingo_geo_basic_default_phone',
			'descr' 	=> 'Этот телефон будет отображаться если не выбран город',
			'post_type'	=> false
		)
	);

	add_settings_field( 
		'belingo_geo_basic_default_address', 
		'Адрес по умолчанию', 
		'belingo_geo_display_settings', 
		$settings_page, 
		'belingo_geo_basic', 
		array( 
			'type'      => 'text',
			'option_name' => 'belingo_geo_basic_default_address',
			'descr' 	=> 'Этот адрес будет отображаться если не выбран город',
			'post_type'	=> false
		)
	);

	add_settings_field(
		'belingo_geo_exclude_terms',
		'Таксономии',
		'belingo_geo_display_settings',
		$settings_page,
		'belingo_geo_excludes',
		array(
			'type'      => 'select',
			'option_name' => 'belingo_geo_exclude_terms',
			'descr' 	=> 'Таксономии, выбранные в этом списке будут исключены из работы плагина, вместе с таксономией будут исключены все вложенные записи',
			'post_type'	=> 'term'	
		)
	);

	add_settings_field(
		'belingo_geo_exclude_posts',
		'Записи',
		'belingo_geo_display_settings',
		$settings_page,
		'belingo_geo_excludes',
		array(
			'type'      => 'select',
			'option_name' => 'belingo_geo_exclude_posts',
			'descr' 	=> 'Записи, выбранные в этом списке будут исключены из работы плагина',
			'post_type'	=> 'post'	
		)
	);

	add_settings_field(
		'belingo_geo_exclude_pages',
		'Страницы',
		'belingo_geo_display_settings',
		$settings_page,
		'belingo_geo_excludes',
		array(
			'type'      => 'select',
			'option_name' => 'belingo_geo_exclude_pages',
			'descr' 	=> 'Страницы, выбранные в этом списке будут исключены из работы плагина',
			'post_type'	=> 'page'	
		)
	);

	add_settings_field( 
		'belingo_geo_basic_brand_base', 
		'База woocommerce бренд', 
		'belingo_geo_display_settings', 
		$settings_page, 
		'belingo_geo_basic', 
		array( 
			'type'      => 'text',
			'option_name' => 'belingo_geo_basic_brand_base',
			'descr' 	=> 'Если используются плагины формирующие таксономию с брендами для woocommerce, укажите тут url базу',
			'post_type'	=> false
		)
	);

	add_settings_field( 
		'belingo_geo_basic_brand_term', 
		'База woocommerce бренд term name', 
		'belingo_geo_display_settings', 
		$settings_page, 
		'belingo_geo_basic', 
		array( 
			'type'      => 'text',
			'option_name' => 'belingo_geo_basic_brand_term',
			'descr' 	=> 'Если используются плагины формирующие таксономию с брендами для woocommerce, укажите тут имя таксономии',
			'post_type'	=> false
		)
	);

}
add_action( 'admin_init', 'belingo_geo_settings' );


function belingo_geo_display_settings($args) {
	extract( $args );

	$belingo_geo_exclude = get_option( $option_name );

	if(!$belingo_geo_exclude) {
		$belingo_geo_exclude = [];
	}

	if($post_type != 'term') {

		switch ( $type ) {

			case 'select':

				$posts = get_posts( array(
					'post_type'   => $post_type,
					'include'     => $belingo_geo_exclude
				) );

				wp_reset_postdata(); // сброс

				echo "<select multiple class='select2_field' id='".$option_name."' name='" . $option_name . "[]' style='min-width: 300px;'>";

				if(count($belingo_geo_exclude)>0) {
					foreach($posts as $post){
						echo "<option value='".$post->ID."' selected>".$post->post_title."</option>";
					}
				}

				echo ($desc != '') ? $desc : "";
				echo "</select>";
				echo "<p class='description'>".$descr."</p>";
				break;

			case 'text':
				echo "<input type='text' id='".$option_name."' name='" . $option_name . "' value='".get_option($option_name)."' style='min-width: 300px;'>";
				echo "<p class='description'>".$descr."</p>";
			break;

		}
	}elseif($post_type == 'term') {
		$terms = get_terms( array(
			'taxonomy'   => 'category',
			'include'     => $belingo_geo_exclude
		) );

		wp_reset_postdata(); // сброс

		switch ( $type ) {

			case 'select':
				echo "<select multiple class='select2_field' id='".$option_name."' name='" . $option_name . "[]' style='min-width: 300px;'>";

				if(count($belingo_geo_exclude)>0) {
					foreach($terms as $term){
						echo "<option value='".$term->term_id."' selected>".$term->name."</option>";
					}
				}

				echo ($desc != '') ? $desc : "";
				echo "</select>";
				echo "<p class='description'>".$descr."</p>";
				break;
		}
	}
}

?>